// Class Code Set 15C
// newing arrays
// parallel arrays

final int MAX = 1000;

PImage moose;

int [ ] xCoords;
int [ ] yCoords;
int [ ] zCoords;
int [ ] zDelta;
int [ ] boxSize;
int [ ] xRot;
int [ ] yRot;
int [ ] zRot;
color [ ] cols;

void setup ()
{
  size( screen.width, screen.height, P3D );
  
  xCoords = new int[ MAX ];
  yCoords = new int[ MAX ];
  zCoords = new int[ MAX ];
  zDelta = new int[ MAX ];
  boxSize = new int[ MAX ];
  xRot = new int[ MAX ];
  yRot = new int[ MAX ];
  zRot = new int[ MAX ];
  cols = new color[ MAX ];
  
  initCoords( xCoords, -10, width );
  initCoords( yCoords, -10, height );
  initCoords( zCoords, -10000, 0 );
  initCoords( zDelta, 5, 15 );
  initCoords( boxSize, 5, 50 );
  initCoords( xRot, -5, 5 );
  initCoords( yRot, -5, 5 );
  initCoords( zRot, -5, 5 );
  initColors( );
  
  strokeWeight( 2 );
  
  moose = loadImage( "moose.jpg" );
}

void draw ( )
{
  background( 0 );
  lights( );
  moveBoxes( );
  plotBoxes( );  
}

void initCoords( int [ ] coords, int  min, int max )
{
  for( int i = 0 ; i < coords.length ; i++ )
  {
    coords[i] = int( random( min, max ) );
  }
}

void initColors(   )
{
  for( int i = 0 ; i < cols.length ; i++ )
  {
    float r = random( 255 );
    float g = random( 255 );
    float b = random( 255 );
    cols[i] = color( r, g, b );
  }
}

void moveBoxes( )
{
  for( int i = 0 ; i < cols.length ; i++ )  
  {
    zCoords[i] += zDelta[i];
    if ( zCoords[i] >= 1000 )
    {
       zCoords[i] = -10000; 
    }
  }  
}

void plotBoxes ( )
{
  for( int i = 0 ; i < cols.length ; i++ )  
  {

    fill( cols[i]);
    pushMatrix( );
      translate (xCoords[i], yCoords[i], zCoords[i] );
      rotateX( -radians( frameCount)*xRot[i] );
      rotateY( -radians( frameCount)*yRot[i] );
      rotateZ( -radians( frameCount)*zRot[i] );
      box( boxSize[i] );
      if ( i%10 == 0 )
      {
        pushMatrix( );
         translate( -boxSize[i]/2, -boxSize[i]/2, -boxSize[i]/2 - 2);
         image( moose, 0, 0, boxSize[i], boxSize[i] );
        popMatrix( );
      }
    popMatrix( );
  }
}
